"use strict";
var _a;
Object.defineProperty(exports, "__esModule", { value: true });
exports.nodeVersion = exports.getRuntime = exports.platformIsValid = exports.supportedPlatforms = void 0;
const node_process_1 = require("process");
const regex = /v(\d+)\./;
exports.supportedPlatforms = [
    'node',
    'bun',
    'deno',
];
const platformIsValid = (platform) => {
    if (typeof platform === 'string' &&
        exports.supportedPlatforms.some((supportedPlatform) => supportedPlatform === platform)) {
        return true;
    }
    return false;
};
exports.platformIsValid = platformIsValid;
const getRuntime = (configs) => {
    if ((configs === null || configs === void 0 ? void 0 : configs.platform) && (0, exports.platformIsValid)(configs.platform)) {
        return configs.platform;
    }
    /* c8 ignore start */
    if (typeof Deno !== 'undefined') {
        return 'deno';
    }
    /* c8 ignore stop */
    /* c8 ignore start */
    if (typeof Bun !== 'undefined') {
        return 'bun';
    }
    /* c8 ignore stop */
    return 'node';
};
exports.getRuntime = getRuntime;
/* c8 ignore start */
exports.nodeVersion = (0, exports.getRuntime)() === 'node' ? Number((_a = node_process_1.version.match(regex)) === null || _a === void 0 ? void 0 : _a[1]) : undefined;
/* c8 ignore stop */
